﻿Imports System.IO
Imports System.Net
Imports System.Data

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        'FTP Server URL.
        Dim ftp As String = "ftp://yourserver.com/"

        'FTP Folder name. Leave blank if you want to list files from root folder.
        Dim ftpFolder As String = "Uploads/"

        Try
            'Create FTP Request.
            Dim request As FtpWebRequest = DirectCast(WebRequest.Create(ftp & ftpFolder), FtpWebRequest)
            request.Method = WebRequestMethods.Ftp.ListDirectoryDetails

            'Enter FTP Server credentials.
            request.Credentials = New NetworkCredential("Username", "Password")
            request.UsePassive = True
            request.UseBinary = True
            request.EnableSsl = False

            'Fetch the Response and read it using StreamReader.
            Dim response As FtpWebResponse = DirectCast(request.GetResponse(), FtpWebResponse)
            Dim entries As New List(Of String)()
            Using reader As New StreamReader(response.GetResponseStream())
                'Read the Response as String and split using New Line character.
                entries = reader.ReadToEnd().Split(New String() {Environment.NewLine}, StringSplitOptions.RemoveEmptyEntries).ToList()
            End Using
            response.Close()

            'Create a DataTable.
            Dim dtFiles As New DataTable()
            dtFiles.Columns.AddRange(New DataColumn(2) { _
                                     New DataColumn("Name", GetType(String)), _
                                     New DataColumn("Size", GetType(Decimal)), _
                                     New DataColumn("Date", GetType(String))})

            'Loop and add details of each File to the DataTable.
            For Each entry As String In entries
                Dim splits As String() = entry.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)

                'Determine whether entry is for File or Directory.
                Dim isFile As Boolean = splits(0).Substring(0, 1) <> "d"
                Dim isDirectory As Boolean = splits(0).Substring(0, 1) = "d"

                'If entry is for File, add details to DataTable.
                If isFile Then
                    dtFiles.Rows.Add()
                    dtFiles.Rows(dtFiles.Rows.Count - 1)("Size") = Decimal.Parse(splits(4)) / 1024
                    dtFiles.Rows(dtFiles.Rows.Count - 1)("Date") = String.Join(" ", splits(5), splits(6), splits(7))
                    Dim name As String = String.Empty
                    For i As Integer = 8 To splits.Length - 1
                        name = String.Join(" ", name, splits(i))
                    Next
                    dtFiles.Rows(dtFiles.Rows.Count - 1)("Name") = name.Trim()
                End If
            Next

            'Bind the GridView.
            gvFiles.DataSource = dtFiles
            gvFiles.DataBind()
        Catch ex As WebException
            Throw New Exception(TryCast(ex.Response, FtpWebResponse).StatusDescription)
        End Try
    End Sub

    Protected Sub DownloadFile(sender As Object, e As EventArgs)
        Dim fileName As String = TryCast(sender, LinkButton).CommandArgument

        'FTP Server URL.
        Dim ftp As String = "ftp://yourserver.com/"

        'FTP Folder name. Leave blank if you want to Download file from root folder.
        Dim ftpFolder As String = "Uploads/"

        Try
            'Create FTP Request.
            Dim request As FtpWebRequest = DirectCast(WebRequest.Create(Convert.ToString(ftp & ftpFolder) & fileName), FtpWebRequest)
            request.Method = WebRequestMethods.Ftp.DownloadFile

            'Enter FTP Server credentials.
            request.Credentials = New NetworkCredential("Username", "Password")
            request.UsePassive = True
            request.UseBinary = True
            request.EnableSsl = False

            'Fetch the Response and read it into a MemoryStream object.
            Dim resp As FtpWebResponse = DirectCast(request.GetResponse(), FtpWebResponse)
            Using stream As New MemoryStream()
                'Download the File.
                resp.GetResponseStream().CopyTo(stream)
                Response.AddHeader("content-disposition", "attachment;filename=" & fileName)
                Response.Cache.SetCacheability(HttpCacheability.NoCache)
                Response.BinaryWrite(stream.ToArray())
                Response.End()
            End Using
        Catch ex As WebException
            Throw New Exception(TryCast(ex.Response, FtpWebResponse).StatusDescription)
        End Try
    End Sub
End Class
